;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:jourdsmois
;
; PURPOSE:donne le nombre de jours ds le mois month de l'annee year
;
; CATEGORY:
;
; CALLING SEQUENCE:result=jourdsmois()
;
; INPUTS:optionnels
;	 mois et annee
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;
; COMMON BLOCKS:
;	common.pro	leapyr.pro
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY: Sebastien Masson (smasson@lodyc.jussieu.fr)
;			2/7/98
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function jourdsmois, mois,annee
@common
;------------------------------------------------------------
case n_params() of
  1:month=mois
  2:begin
      month=mois
      year=annee
    end
  else:
endcase
;------------------------------------------------------------
days_in_mth = [31,28+leapyr(year),31,30,31,30,31,31,30,31,30,31]
return, days_in_mth[month-1]
;------------------------------------------------------------
end
